#!/usr/bin/wish

# Copyright (c) 2002-2014, Botik Technologies, Ltd.
# See license.txt for more information.

# ================= Options =========================================================
#
# 
#
#     readIniFile { }
#     runOptions { }
# 
#     vCMD { cmd }                     --  1     $cmd
#     validateVerbose { }
#     validateMinimized { }            --  ,  $botikkey(minimized) = 0,1
#     validateIconType { }             --  ,  $botikkey(icontype)  = 0,1,2 (  )
#
# 
#
#     global botikkey
#     global bkOptions
#     global bkLog
#     global tcl_platform

global bkOptions
set    bkOptions(width)      740 ; #  
set    bkOptions(height)     400 ; #  
set    bkOptions(bg)     gray84 ; # background 
set    bkOptions(bgo)    gray75 ; # background 
set    bkOptions(relief)   ridge ; # relief  
set    bkOptions(clientStarted) 0; #    , . setVarsOptions  readIniFile

set    bkOptions(promt_use_removable_disk) 1 ;     #         ,
                                                   # . chFileForPswdOptioms
set    bkOptions(pauseBeforPromptForPswd) 120000 ; #   2 .:        ..."
                                                   # . readIniFile
                                               
global iface
if {[windowsPlatform]} {
        set iface(font1)  {Arial 10 bold}
        set iface(font2)  {Helvetica 10 bold}
        set iface(font3)  {Courier 10 bold}
        set iface(font4)  {Courier 10}
        set iface(font5)  {Helvetica 10}
        set iface(font6)  {Courier 2}
} else {
        set iface(font1)  {Courier 13 bold}
        set iface(font2)  {Courier 13 bold}
        set iface(font3)  {Courier 11 bold}
        set iface(font4)  {Courier 11}
        set iface(font5)  {Courier 13}
        set iface(font6)  {Courier 2}
}
                                               
# ""            /          ""  (  e)
#
# botikkey(minimized)      validateMinimized[Optioms]  bkOptions(minimized)
# botikkey(icontype)       validateIconType[Optioms]   bkOptions(icontype)
# botikkey(showLog)        validateShowLogOptioms      bkOptions(showLog)
# botikkey(verbose)        validateVerbose[Optioms]    bkOptions(verbose)
#                                                      bkOptions(password)
# botikkey(d_password)     ---                         bkOptions(d_password)
# botikkey(save_pswd)      validateSavePswdOptioms     bkOptions(save_pswd)
# botikkey(user_pswd_file) chFileForPswdOptioms        bkOptions(user_pswd_file)


#                                     --  1     $cmd

proc vCMD { cmd } {
   after 10 $cmd
   return 1
}

# -------------------------------------- / ""  
proc validateVerbose { } {
   global botikkey
   global bkLog
   if [string is integer -strict $botikkey(verbose) ] {
      set botikkey(verbose) [limits $botikkey(verbose) $bkLog(minV) $bkLog(maxV)]
   } else {
      set botikkey(verbose) $bkLog(maxV)
   }
   return $botikkey(verbose)
}

proc validateMinimized { } {
   global botikkey
   return [set botikkey(minimized) [limits $botikkey(minimized) 0 1] ]
}

proc validateRegionInit { } {
   global botikkey
   if { [lsearch -exact {NONE LOCAL WORLD} $botikkey(region_init) ] == -1} {
      set botikkey(region_init) NONE
   }
   return $botikkey(region_init)
}

proc validateIconType { } {
   global botikkey

   if {[windowsPlatform]} {
      set botikkey(icontype) [limits $botikkey(icontype) 1 2]
   } else {
      set botikkey(icontype) 0
   }
   return $botikkey(icontype)
}

# -------------------------------------- / ""  
proc validateVerboseOptions { } {
   global bkOptions
   global bkLog
   if [string is integer -strict $bkOptions(verbose) ] {
      set bkOptions(verbose) [limits $bkOptions(verbose) $bkLog(minV) $bkLog(maxV)]
   } else {
      set bkOptions(verbose) $bkLog(maxV)
   }
   return 1
}

proc validateMinimizedOptions { } {
   global bkOptions
   set bkOptions(minimized) [limits $bkOptions(minimized) 0 1]
   return 1
}

proc validateShowLogOptions { } {
   global bkOptions
   set bkOptions(showLog) [limits $bkOptions(showLog) 0 1]
   return 1
}

proc validateIconTypeOptions { } {
   global bkOptions
   if {[windowsPlatform]} {
      set bkOptions(icontype) [limits $bkOptions(icontype) 1 2]
   } else {
      set bkOptions(icontype) 0
   }
   return 1
}

proc validateSavePswdOptions { } {
   global bkOptions
   if [string is integer -strict $bkOptions(save_pswd) ] {
      set bkOptions(save_pswd) [limits $bkOptions(save_pswd) 1 4]
   } else {
      set bkOptions(save_pswd) 1
   }
   return 1
}   

proc readPswd { } {
   global bkOptions botikkey
   set types {
       {{All Files}        *             }
       {{Text Files}       {.txt}        }
   }
   set idir [file dirname $botikkey(dflt_pswd_file)]
   set readFileName [file tail $botikkey(dflt_pswd_file)]
   if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
   set filename [tk_getOpenFile -filetypes $types -defaultextension * -parent $parent \
                                -title "  ,   ?" \
                                -initialfile $readFileName -initialdir $idir]
   if {![llength $filename]} {return}
   readPswdFromFile $filename
   return
}

proc readPswdFromFile { fname } {
   global bkOptions
   #     fname

   set goon "retry"
   set d_password ""
   set done 0
   while { $goon eq "retry" } {
      set ok 0
      catch {
         #     $fname
         set out [open $fname r]
         set d_password [gets $out]
         close $out
         if { [string length $d_password] == 0 } {
            error "File \"$fname\" is empty"
         }
         set ok 1
      } rc
      if { !$ok } {
         if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
         set msg  "      \n\"$fname\"\n\n[mkErrorCode $rc]"
         set goon [ tk_messageBox -icon warning -type retrycancel -parent $parent -default retry \
                        -title "   " \
                        -message $msg]
         catch { close $out }
      } else {
         set done 1
         set goon cancel
      }
   }

   if { ! $done } {
      return
   }

   set regexp_pswd {^[0-9a-f]*$}

   if { ([string length $d_password] != 32) || (! [regexp $regexp_pswd $d_password]) } {
      if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
      set msg "     \n\"$fname\"\n( 32  ,   \"$d_password\")"
      set goon [ tk_messageBox -icon warning -type retrycancel  -parent $parent -default retry \
                     -title "   " \
                     -message $msg ]
      showHelp HelpForOptions
      return
   }
   set bkOptions(d_password) $d_password
   return
}

proc chFileForPswdOptioms { } {
   global bkOptions botikkey

   if { $bkOptions(promt_use_removable_disk) } {
      message info "  \
                     (, Flash/USB-)\
                       (. )"
      set bkOptions(promt_use_removable_disk) 0
   }

   set types {
       {{All Files}        *             }
       {{Text Files}       {.txt}        }
   }

   set idir [file dirname $botikkey(dflt_pswd_file)]
   set writeFileName [file tail $botikkey(dflt_pswd_file)]
   if {[winfo exists .wBkOptions]} { set parent .wBkOptions } else { set parent . }
   set filename [tk_getSaveFile -filetypes $types -defaultextension * -parent $parent \
                                -title "    ?" \
                                -initialfile $writeFileName -initialdir $idir]
   if {![llength $filename]} {
      set filename "**  **"
   } else {
      set bkOptions(save_pswd) 4
      set bkOptions(user_pswd_file) $filename
   }
   catch { .wBkOptions.rup.spswd.rest.t configure -text [leftDots 30 $bkOptions(user_pswd_file)] }
   return
}
# ================================================ / 
proc getVarsOptions { } {
   global botikkey bkOptions
   set bkOptions(minimized)      $botikkey(minimized)
   set bkOptions(icontype)       $botikkey(icontype)
   set bkOptions(showLog)        $botikkey(showLog)
   set bkOptions(verbose)        $botikkey(verbose)
   set bkOptions(region_init)    $botikkey(region_init)
   set bkOptions(password)       ""
   set bkOptions(d_password)     ""
   set bkOptions(save_pswd)      $botikkey(save_pswd)
   set bkOptions(user_pswd_file) $botikkey(user_pswd_file)
   set bkOptions(addr)           $botikkey(addr)
   return
}

proc chkVarsOptions { } {
   global botikkey bkOptions
   if { [string length $bkOptions(password)] > 0 } {
      set bkOptions(d_password)    [pswdToKey $bkOptions(password)]
   } elseif {[string length $bkOptions(d_password)] == 0} {
      set bkOptions(d_password)    $botikkey(d_password)
   }
   set bkOptions(same_icontype)  [expr {$bkOptions(icontype)   eq $botikkey(icontype)  }]
   set bkOptions(same_password)  [expr {$bkOptions(d_password) eq $botikkey(d_password)}]
   set bkOptions(empty_password) [expr {$bkOptions(d_password) eq $botikkey(md5_empty) }]
   set bkOptions(wrong_addr)     [expr {[string length $bkOptions(addr)] == 0 || ![isLocal $bkOptions(addr) $bkOptions(addr)]}]
   set bkOptions(same_addr)      [expr {$bkOptions(addr) eq $botikkey(addr)}]
   return
}

proc setVarsOptions { } {
   global botikkey bkOptions
   chkVarsOptions
   if {!$bkOptions(wrong_addr) && !$bkOptions(same_addr)} {
      set botikkey(addr) $bkOptions(addr)
      writeLogChangeStatus 0 GRAY "[strTime]  ( )  Key-"
   }
   set botikkey(minimized)      $bkOptions(minimized)      
   set botikkey(icontype)       $bkOptions(icontype)       
   set botikkey(showLog)        $bkOptions(showLog)
   set botikkey(verbose)        $bkOptions(verbose)        
   set botikkey(save_pswd)      $bkOptions(save_pswd)      
   set botikkey(user_pswd_file) $bkOptions(user_pswd_file) 
   set botikkey(region_init)    $bkOptions(region_init)
   if { ! $bkOptions(same_icontype) } { resetIcons }
   if { (! $bkOptions(same_password) ) && (! $bkOptions(empty_password)) } {
      set botikkey(d_password)  $bkOptions(d_password)
      writeLogChangeStatus 0 GRAY "[strTime]  ( ) / "
      if { ! $bkOptions(clientStarted) } {
         set botikkey(region_by_user) [set botikkey(region_request) $botikkey(region_init)]
         set bkOptions(clientStarted) 1
         writeLogChangeStatus 0 GRAY "[strTime]    "
         restartClient
      }
   }
   if {!$bkOptions(wrong_addr) && !$bkOptions(same_addr)} {
      writeLogChangeStatus 0 GRAY "[strTime]    "
      restartClient
   }
   return
}

proc runOptions { } {
   createOptionsWindow
   popUpOptionsWindow
}

proc popUpOptionsWindow { } {
   catch { wm deiconify .wBkOptions; raise .wBkOptions; focus -force .wBkOptions.rup.pswd.e; }
   update
   return
}

proc createOptionsWindow { } {
   global botikkey bkOptions myImages bkLog tcl_platform iface
   if { [winfo exists .wBkOptions] } {
      return
   }

   getVarsOptions
   toplevel .wBkOptions -width $bkOptions(width) -height $bkOptions(height)
   #catch "wm iconbitmap .wBkOptions $botikkey(currentIcon)"
   wm title .wBkOptions "  $botikkey(version)"
   wm iconname .wBkOptions "Options::$botikkey(version)"
   setWindowIcon .wBkOptions

#      ===================================================================

   frame .wBkOptions.left -width $bkOptions(width) -bd 3 -relief $bkOptions(relief)
   pack  .wBkOptions.left -side left -fill both -padx 3 -pady 3 ; # -anchor e 

#   
#
#    [ ]                   0/1 bkOptions(minimized)

   validateMinimizedOptions
   labelframe .wBkOptions.left.start -text "  " -font $iface(font2) -bd 2
   pack  .wBkOptions.left.start -padx 4 -pady 4 -side top -fill x -anchor w
   checkbutton .wBkOptions.left.start.as_icon -text " " \
         -font $iface(font5)  -anchor w -variable bkOptions(minimized)
   pack  .wBkOptions.left.start.as_icon -side top -anchor w -pady 0 -padx 2
   frame .wBkOptions.left.start.reg
   pack  .wBkOptions.left.start.reg -side top -anchor w -pady 0 -padx 2
   label .wBkOptions.left.start.reg.t -text " : " -font $iface(font5)
   tk_optionMenu .wBkOptions.left.start.reg.m bkOptions(region_init) WORLD LOCAL NONE
   pack  .wBkOptions.left.start.reg.t .wBkOptions.left.start.reg.m -side left -anchor w -pady 0 -padx 0

#    :                    bkOptions(icontype) 
# 
#    ( ) Unix/Mac: ,              0
#    (*) Windows,                   1
#    ( ) Windows,                  2

   validateIconTypeOptions
   labelframe .wBkOptions.left.icontype -text "   " -font $iface(font2)
   pack  .wBkOptions.left.icontype -padx 4 -pady 4 -side top -fill x -anchor w
   foreach {type txt val} {      unix_macintosh "Unix/Mac, , " 0
                                 windows_1      "Windows,    "   1
                                 windows_2      "Windows,    "  2
   } {
         if {[string first $tcl_platform(platform) $type] < 0 || $type eq "windows_1"} {
            set state disabled
         } else {set state normal}
         radiobutton .wBkOptions.left.icontype.$type -text  $txt -value $val\
            -font $iface(font5)  -anchor w -relief flat -variable bkOptions(icontype) \
            -command {vCMD validateIconTypeOptions} -state $state
         pack  .wBkOptions.left.icontype.$type -side top -anchor w  -fill x -padx 2 -pady 0
   }

#    /:
#    [x]                (0,1) bkOptions(showLog)

   validateShowLogOptions
   labelframe .wBkOptions.left.showLog -text "   /" -font $iface(font2) -bd 2
   pack  .wBkOptions.left.showLog -padx 4 -pady 4 -side top -fill x -anchor w
   checkbutton .wBkOptions.left.showLog.cb -text "    " \
         -font $iface(font5)  -anchor w -variable bkOptions(showLog)
   pack  .wBkOptions.left.showLog.cb -side left -anchor w -pady 0 -padx 2 
 
#  
# 
# [0..3]  

   labelframe .wBkOptions.left.logLevel -text "  " \
                  -font $iface(font2) -bd 2
   pack    .wBkOptions.left.logLevel -padx 4 -pady 4 -side top -fill x -anchor w
   validateVerboseOptions
   spinbox .wBkOptions.left.logLevel.verbs -from $bkLog(minV) -to $bkLog(maxV) -increment 1 -width 2 \
           -textvariable bkOptions(verbose) -validate all -vcmd {vCMD validateVerboseOptions}
   label   .wBkOptions.left.logLevel.vlabl -text " " -font $iface(font5) -anchor w
   pack    .wBkOptions.left.logLevel.verbs .wBkOptions.left.logLevel.vlabl  -side left -pady 2 -padx 2  -anchor w

#  Key-

   labelframe .wBkOptions.left.addr -text " -" -font $iface(font2) -bd 2
   pack    .wBkOptions.left.addr -padx 4 -pady 4 -side top -fill x -anchor w
   entry .wBkOptions.left.addr.e -width 35  -font $iface(font5)  -textvariable bkOptions(addr)
   pack  .wBkOptions.left.addr.e -side top -anchor sw -fill x -padx 2 -pady 2
   if {$botikkey(addr) ne "" && $bkOptions(addr) eq ""} {
      set bkOptions(addr) $botikkey(addr) 
   }
   checkbutton .wBkOptions.left.addr.cb -command "toggle_gbk_label .wBkOptions.left.addr" \
      -variable botikkey(gbk) -text "   gbotikkeyd"
   pack .wBkOptions.left.addr.cb -padx 4 -pady 4 -side top -fill x
   proc toggle_gbk_label {lf} {
        global bkOptions botikkey
        if {$botikkey(gbk)} {
            $lf configure -text " gbotikkeyd-"
            set ::bkaddr $bkOptions(addr)
            set bkOptions(addr) $botikkey(gbk_ip)
        } else {
            $lf configure -text " -"
            if {![info exists ::bkaddr]} {return}
            set bkOptions(addr) $::bkaddr
        }
   }
#    ===================================================================

   frame .wBkOptions.rup -width $bkOptions(width) -bd 3 -relief $bkOptions(relief)
   pack  .wBkOptions.rup -side top -fill both -padx 3 -pady 3 -anchor ne

# 
#  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

   labelframe .wBkOptions.rup.pswd -text "" -font $iface(font2) -bd 2
   pack  .wBkOptions.rup.pswd -padx 4 -pady 4 -side top -fill x -anchor w
   entry .wBkOptions.rup.pswd.e -show "*" -width 35  -font $iface(font5)  -textvariable bkOptions(password)
   pack  .wBkOptions.rup.pswd.e -side left -anchor sw -fill x -padx 2 -pady 2
   focus -force .wBkOptions.rup.pswd.e

   setImgButtons .wBkOptions.rup.pswd 2 2 right se [subst { 
         read  $myImages(readPswd) readPswd
   } ]

#   
# (*)   
# ( )    
# ( )     
# ( )      :
#              "**  **" []

   labelframe .wBkOptions.rup.spswd -text "  " -font $iface(font2) -bd 2
   pack .wBkOptions.rup.spswd -padx 4 -pady 4 -side top -fill x -anchor w

   foreach {type txt val} {      o1 "  "                        1
                                 o2 "   "                2
                                 o3 "    "   3
                                 o4 "     :" 4
   } {   radiobutton .wBkOptions.rup.spswd.$type -text  $txt -value $val \
            -font $iface(font5)  -anchor w -relief flat -variable bkOptions(save_pswd) \
            -command {vCMD validateSavePswdOptions}
         pack .wBkOptions.rup.spswd.$type -side top -anchor w  -fill x -padx 2 -pady 0
   }

#              "**  **" []

   frame .wBkOptions.rup.spswd.rest
   pack  .wBkOptions.rup.spswd.rest -side top -anchor e -padx 0 -pady 0
   label .wBkOptions.rup.spswd.rest.t -text [leftDots 31 $bkOptions(user_pswd_file)] -font $iface(font2)
   setImgButtons .wBkOptions.rup.spswd.rest 2 2 right e [subst { 
         chfile  $myImages(fnameNormal) chFileForPswdOptioms 
   } ]
   pack  .wBkOptions.rup.spswd.rest.t -side right -anchor e  -padx 2 -pady 2

#  

    set opts .wBkOptions.rup

    checkbutton $opts.cb -text "  " -font $iface(font2) -variable botikkey(notifcn,on_) -anchor w -command [list changeSlavesState $opts.lf]
    labelframe $opts.lf -labelwidget $opts.cb
    pack $opts.lf -side top -fill both -expand 1
    frame $opts.lf.row1
    frame $opts.lf.row2
    pack $opts.lf.row1 $opts.lf.row2 -side top -expand 1 -fill both
    label $opts.lf.row1.l -text "  ; :" -font $iface(font5)
    tk_optionMenu $opts.lf.row1.menu botikkey(notifcn1,access_) "$botikkey(notifcn,str_nochange)" "LOCAL" "NONE"
    pack $opts.lf.row1.l $opts.lf.row1.menu -side left
    label $opts.lf.row2.l -text "   ; :" -font $iface(font5)
    tk_optionMenu $opts.lf.row2.menu botikkey(notifcn2,access_) "$botikkey(notifcn,str_nochange)" "LOCAL" "NONE"
    pack $opts.lf.row2.l $opts.lf.row2.menu -side left
    if {!$botikkey(notifcn,on)} {
        changeSlavesState $opts.lf
    }

#  ===================================================================
   frame .wBkOptions.rightdn -width $bkOptions(width)
   pack  .wBkOptions.rightdn -side bottom -padx 3 -pady 3 -anchor se

   setImgButtons .wBkOptions.rightdn 2 2 right e [subst { 
         no    $myImages(noNormal)          cancelOptions 
         apply $myImages(yesNormal)         applyOptions 
         yes   $myImages(yesAndWriteNormal) applyAndSaveOptions 
         help  $myImages(helpNormal)        {showHelp HelpForOptions}
   } ]
    update
   changesInHelpWindow HelpForOptions
   return
}
proc changeSlavesState {mf} {
    set slist [concat [pack slaves $mf.row1] [pack slaves $mf.row2]]
    foreach slave $slist {
        if {$::botikkey(notifcn,on_)} {
            $slave configure -state normal
        } else {
            $slave configure -state disabled
        }
    }
}
proc cancelOptions { } {
   catch {
      destroy .wBkOptions
      .mw.right.bsetup configure -state normal
      update
   }
   return
}

proc applyOptions { } {
   global botikkey bkOptions

   if {!$botikkey(notifcn,on_)} {
      loop i 1 $botikkey(notifcn,limit) {
         hideNotifcn $i
      }
      set botikkey(notifcn,on) $botikkey(notifcn,on_)
      set botikkey(notifcn1,access) $botikkey(notifcn1,access_)
      set botikkey(notifcn2,access) $botikkey(notifcn2,access_)
   }
   if {$botikkey(notifcn,on_)} {
       if {!$botikkey(notifcn,on)} {
               set botikkey(notifcn,on) $botikkey(notifcn,on_)
               set botikkey(notifcn1,access) $botikkey(notifcn1,access_)
               set botikkey(notifcn2,access) $botikkey(notifcn2,access_)
            readAbonInfo
       } else {
               if {$botikkey(notifcn1,access) ne $botikkey(notifcn1,access_) || $botikkey(notifcn2,access) ne $botikkey(notifcn2,access_)} {
                   set botikkey(notifcn1,access) $botikkey(notifcn1,access_)
                   set botikkey(notifcn2,access) $botikkey(notifcn2,access_)
                readAbonInfo
            }
       }
   }
   setVarsOptions
   if {$botikkey(gbk) && [llength $bkOptions(password)]} {
        sendToGbk "set_password_to\n$bkOptions(password)"
   }
   message info "     ,      \
                     $botikkey(version)"
   catch {
      destroy .wBkOptions
      .mw.right.bsetup configure -state normal
      update
   }
   return
}

proc applyAndSaveOptions { } {
   global botikkey bkOptions

   if {!$botikkey(notifcn,on_)} {
      loop i 1 $botikkey(notifcn,limit) {
         hideNotifcn $i
      }
      set botikkey(notifcn,on) $botikkey(notifcn,on_)
      set botikkey(notifcn1,access) $botikkey(notifcn1,access_)
      set botikkey(notifcn2,access) $botikkey(notifcn2,access_)
   }
   if {$botikkey(notifcn,on_)} {
       if {!$botikkey(notifcn,on)} {
               set botikkey(notifcn,on) $botikkey(notifcn,on_)
               set botikkey(notifcn1,access) $botikkey(notifcn1,access_)
               set botikkey(notifcn2,access) $botikkey(notifcn2,access_)
            readAbonInfo
       } else {
               if {$botikkey(notifcn1,access) ne $botikkey(notifcn1,access_) || $botikkey(notifcn2,access) ne $botikkey(notifcn2,access_)} {
                   set botikkey(notifcn1,access) $botikkey(notifcn1,access_)
                   set botikkey(notifcn2,access) $botikkey(notifcn2,access_)
                readAbonInfo
            }
       }
   }
   chkVarsOptions
   if {!$botikkey(gbk) && $bkOptions(empty_password) } {
      message error "   ."
      return
   }
   if {$botikkey(gbk) && [llength $bkOptions(password)]} {
        sendToGbk "set_password_to\n$bkOptions(password)"
   }
   if { ($bkOptions(save_pswd)==4) && ([string first "*" $bkOptions(user_pswd_file)] >=0) } {
      message error "     ,     \
                       (\"*\"   ).\
                        "
      return
   }

   if {$bkOptions(wrong_addr)} {
      message warning "!     Key-."
   }

   setVarsOptions

   #      :
   set fname  $bkOptions(user_pswd_file)
   if { [string first "*" $fname] >=0 } {
      set fname1 ""
   } else {
      set fname1 $fname
   }
   
   set allOptions "BotikKey-options:$bkOptions(minimized):$bkOptions(region_init):$bkOptions(icontype):$bkOptions(showLog):$bkOptions(verbose):$bkOptions(save_pswd):$fname1:$bkOptions(addr)"

   set step ""
   set ok 0
   catch {
      # ,     $fname ( ).
      if {$bkOptions(save_pswd) > 2} {
         #     ?
         if { $bkOptions(save_pswd) == 3 } {
            set fname $botikkey(dflt_pswd_file) 
         } else {
            set fname  $bkOptions(user_pswd_file)
         }
         set step "    \n\"$fname\""
         set goon "retry"
         set ok_w 0
         while { $goon eq "retry" } {
            set ok_w 0
            catch {
               #     $fname
                set out [open $fname w]
               puts $out $bkOptions(d_password)
               close $out
               set ok_w 1
            } rc
            if { !$ok_w } {
               catch { close $out }
               set msg "      \n\"$fname\"\n\n[mkErrorCode $rc]"
               set goon [tk_messageBox -icon warning -type retrycancel -default retry \
                              -title "   " \
                              -message $msg]
               #asksendmail $msg
            } else {
               set goon cancel
            }
         }
         if { !$ok_w } { error "Password has not been written to file \"$fname\"\n$rc" }
      }
      #      
      set fname $botikkey(init_file)
      set step "    \"$fname\""
      set out [open $fname w]
      puts $out $allOptions
      puts $out "$botikkey(notifcn,on):$botikkey(notifcn1,access):$botikkey(notifcn2,access)"
      puts $out "$botikkey(gbk):$bkOptions(addr)"
      close $out
      set ok 1
   } rc

   if {!$ok} {
      catch {close $out}
      set msg "     .\n   \
                          \
                    $botikkey(version).\
                      , $step:\n[mkErrorCode $rc]\n\
                      ."
      message error $msg
      asksendmail $msg
      return
   }

   #     
   set list {
         "01234"

         "         ."

         "         \
         \"BOTIKKEY\" .      ( \
          )    ."

         "            ."

         "           ."
       }

   set s [lindex $list $bkOptions(save_pswd) ]

   catch {
      destroy .wBkOptions
      .mw.right.bsetup configure -state normal
      update
   }
   message info "         \
                   $botikkey(version)\n\
               $s\n\
               ,   ,     \
                 (    \
                   \"$::net(name)\")."
   return
}

#proc readIniFile { } { 
#   global bkOptions
#
#   #  ,     ,   
#   #  (. setVarsOptions).  :      
#   #     ..
#   dolog [getWhoAmIInfo]
#   readIniFile
#   # checkPasswordAndClient
#   return
#}

proc checkPasswordAndClient { } {
   global bkOptions

   if { $bkOptions(clientStarted) } {
      return
   }

   message info "      \"$::net(name)\"    .\n\n\
                    .     \
                  \"$::net(name)\",      ."

   if { ![winfo exists .wBkOptions] } {
      runOptions
   } else {
      popUpOptionsWindow
   }
   after $bkOptions(pauseBeforPromptForPswd) { checkPasswordAndClient }
   return
}

proc readIniFile { } {
   global botikkey bkOptions env

   getVarsOptions

   set fname $botikkey(init_file)
   set ok 0
   catch {
      set step "    \"$fname\""
      set out [open $fname r]
      set allOptions [gets $out]
      set notifcn_options [gets $out]
      set gbk_options [gets $out]
      close $out
      if {[llength $gbk_options]} {
          set parts [split $gbk_options :]
          set use_gbk [lindex $parts 0]
          set addr [lindex $parts 1]
          if {[string is integer -strict $use_gbk] && $use_gbk >= 0 && $use_gbk <= 1} {
                set botikkey(gbk) $use_gbk
          }
          if {[llength $addr]} {set bkOptions(addr) $addr}
      }
      if {[llength $notifcn_options]} {
         regexp {^([01]):( |NONE|LOCAL):( |NONE|LOCAL)$} $notifcn_options -> botikkey(notifcn,on) botikkey(notifcn1,access) botikkey(notifcn2,access)
         set botikkey(notifcn,on_) $botikkey(notifcn,on)
         set botikkey(notifcn1,access_) $botikkey(notifcn1,access)
         set botikkey(notifcn2,access_) $botikkey(notifcn2,access)
      }
      if {![regexp {^BotikKey-options:([01]):(NONE|LOCAL|WORLD):([0-2]):([01]):([0-3]):([1-4]):(.*):(.*)$} $allOptions -> bkOptions(minimized) bkOptions(region_init) bkOptions(icontype) bkOptions(showLog) bkOptions(verbose) bkOptions(save_pswd) fname1 bkOptions(addr)] 
      } {
         error "The file \"$fname\" has invalid content"
      }
      set ok 1
   } rc
   if { !$ok } {
      catch { close $out }
      set msg "      \"$fname\".\
                     ,     $botikkey(version)  \
                     .\n\n\
                         .     \
                       \"$::net(name)\",      .\
                           $botikkey(version) - \
                        .\n\n\
                      ,  ()    ()\
                       : $botikkey(url_NadminAbPswd)"
      message info $msg
      runOptions
      return
   }

   if { [string length $fname1 ] == 0 } {
      set fname "**  **"
   } else {
      set fname $fname1
   }

   set bkOptions(user_pswd_file) $fname

   #   ,  ...

   setVarsOptions
   if {$botikkey(minimized)} {
      catch {wm iconify .}
   }

   #  
   set bkOptions(password) ""
   set bkOptions(d_password) ""

   if { $bkOptions(save_pswd) == 2 } {
      set d_password ""
      catch {
         set d_password $env(BOTIKKEY)
         set regexp_pswd {^[0-9a-f]*$}
         if { ([string length $d_password] == 32) && ([regexp $regexp_pswd $d_password]) } {
            set bkOptions(d_password) $d_password
         }
      }
      if { [string length $bkOptions(d_password)] == 0 } {
         if [winfo exists .wBkOptions] { set parent .wBkOptions } else { set parent . }
         set msg "        \"BOTIKKEY\"\
                     ( 32  ,  \"$d_password\")"
         tk_messageBox -icon warning -type ok -parent $parent\
            -title "      " \
            -message $msg
         showHelp HelpEnv
      }
   }

   if { $bkOptions(save_pswd) > 2 } {
      #    ?
      if { $bkOptions(save_pswd) == 3 } {
         set fname $botikkey(dflt_pswd_file)
      } else {
         set fname $bkOptions(user_pswd_file)
      }

      #     fname
      readPswdFromFile $fname
   }
   #    ,      ...

   if { ([string length $bkOptions(password)] == 0) && ([string length $bkOptions(d_password)] == 0) } {
      runOptions
   } else {
      setVarsOptions
   }
   return
}
