# This script allows to modify program without its restart;
# it watches program's file modif. time, and reads in the file if it was modified;
# only procs can be modified this way.
# Can be used in Tk programs.
# Very useful for developers.

set ::code ""
proc K    {x y} {set x}
proc pop  {}    {K [lindex $::stack end] [set ::stack [lrange $::stack 0 end-1]]}
proc push {t}   {lappend ::stack $t}
proc top  {}    {return [lindex $::stack end]}
proc stack_clear {} {set ::stack {}}
# make bracket map for all the program
proc bracket_map {} {
    global code bracket_map
    stack_clear
    set len [string length $code]
    for {set i 0} {$i < $len} {incr i} {
        set c [string index $code $i]
        if {$c eq "\{"} {
            push $i
        } elseif {$c eq "\}"} {
            set left [pop]
            set right $i
            set bracket_map($left) $right
            set bracket_map($right) $left
        }
    }
    return
}
proc count_spaces {str} {
    set len [string length $str]
    set cntr 0
    set str [string map {{  } { }} $str]
    for {set i 0} {$i < $len} {incr i} {
        set c [string index $str $i]
        if {$c eq " "} {incr cntr}
    }
    return $cntr
}
proc doUpdate {filename} {
    global code bracket_map
    set f [open $filename r]
    set code [read $f]
    close $f
    bracket_map
    set len [string length $code]
    set i 0
    set cntr 0
    while {1} {
        set pos [string first "proc " $code $i]
        if {$pos < 0} {break}
        # find the args opening brace
        set arg_br [string first "\{" $code $pos]
        if {$arg_br < 0} {break}
        # test if args are enclosed in braces
        set test [string range $code $pos $arg_br]
        set spaces [count_spaces $test]
        if {$spaces == 2} {
            # args are enclosed in braces, so skip args
            set i $bracket_map($arg_br)
        } elseif {$spaces != 3} {
            incr i
            continue; # smth is wrong...
        }
        if {$spaces == 3} {
            set opening_br $arg_br
        } else {
            set opening_br [string first "\{" $code $i]
        }
        # get the proc body and eval it
        set closing_br $bracket_map($opening_br)
        set body [string range $code $pos $closing_br]
        eval $body
        incr cntr
        set i $closing_br
    }
}
proc uptodate {filename {time 0}} {
    set filename [file join [pwd] $filename]
    set mtime [file mtime $filename]
    if {$mtime > $time} {
        doUpdate $filename
    }
    after 1000 [list uptodate $filename $mtime]
}
proc self_path {} {return [file normalize [info script]]}
proc self_mtime {} {return [file mtime [self_path]]}

# Usage (in your script):
# uptodate [self_path] [self_mtime]
